# Modbus устройство на AVR
# Задание
Устройство поключено к питанию всегда. Взаимодействие по интерфейсу UART (RS-485) и протоколу Modbus.
- Discrete Inputs  - 4 штуки
- Coils - 4 штуки
- Input registers - 2 канала АЦП
- Holding Registers - 1 штука: адрес на шине Modbus.
Адрес по умолчанию 0х32. Адрес хранить в ПЗУ чипа.
Адреса данных определить самостоятельно.
# Участники
Южакова Лада
Салангина Анастасия
Макуц Ольга
# Задачи
Южакова Лада:
- Изучить, как переопределять адрес по умолчанию в ПЗУ
- Изучить ПЗУ
- Изучить АЦП
- Изучить, как определять адреса данных в ПЗУ
- Понять, в какой последовательности будет работать программа
- Изучить, что такое верхняя архитектура

Салангина Анастасия:
- Изучить Modbus
- Определить, как происходит передача по протоколу

Макуц Ольга:
- Изучить UART
- Разобрать назначение и способы использования регистров и вхоов-выходов
- Изучить, как использовать RX/TX
- Изучить кольцевой буфер