
#define On 1
#define Off 0
#define Change_output 10
#define discrete_output_reading 11


volatile unsigned char Data_Rx_ModbasRtu[30];//  
volatile unsigned char quantity_Data_ModbasRtu; //  
//Volatile     C/C++,     ,              
volatile unsigned int Data_ModbasRtu_analog_input[1]; //    [1 -   ]
volatile unsigned int Data_ModbasRtu_analog_Output[1]; //    [1 -   ]
volatile unsigned char Data_ModbasRtu_Binary_input[(1/8)+1]; //    [1 -   ]
volatile unsigned char Data_ModbasRtu_Binary_Output[(1/8)+1]; //    [1 -   ]


//    (Data_Rx_ModbasRtu)
//  int rb_get(struct rb* _rb, char *element)
Data_Rx_ModbasRtu = rb_get(&, 1);


// (+)
int crc_chk(unsigned char* data, unsigned char length)
{
	register int j; // register - ,  ,      
	register unsigned int reg_crc = 0xFFFF; // 16- 
	while (length--)
	{
		reg_crc ^= *data++; // -          .   8                8 
		for (j = 0; j < 8; j++)
		{
			if (reg_crc & 0x01) //  
			{
				reg_crc = (reg_crc >> 1) ^ 0xA001; //    .            .    = 1,           
			}
			else
			{
				reg_crc = reg_crc >> 1; //   = 0,    
			}
		}
	}
	return reg_crc; //     
}


//  (  )
int ModbasRtu_Register_address(unsigned char Li)
//Hi -  
//Li - 
{
	register char Hi = Li - 1;
	return  Data_Rx_ModbasRtu[Hi] * 256 + Data_Rx_ModbasRtu[Li]; //     
}

//
int Modbus_addr()
{
	volatile unsigned int adres;
	adres = ModbasRtu_Register_address(1);
}

//      
char Data_integrity()
{
	register unsigned int Temp_2;
	register unsigned char Temp_3;
	quantity_Data_ModbasRtu = quantity_Data_ModbasRtu - 2; //    
	Temp_2 = crc_chk(Data_Rx_ModbasRtu, quantity_Data_ModbasRtu); //  
	Temp_3 = Temp_2; //     
	if (Data_Rx_ModbasRtu[quantity_Data_ModbasRtu] == Temp_3) //       
	{
		quantity_Data_ModbasRtu++; //  
		Temp_3 = (Temp_2 >> 8); //  8 
		if (Data_Rx_ModbasRtu[quantity_Data_ModbasRtu] == Temp_3) // 
		{
			return 1;
		}
	}
	return 0;
}


//     
char _Bin_input_Output(register unsigned char NUMBER, register unsigned char state, volatile unsigned char* Masiv, volatile unsigned char Sd)
{
	volatile unsigned char Temp = 0, Temp_1 = 0;
	while (NUMBER >= 8)
	{
		NUMBER = NUMBER - 8;
		Temp++; //,        
	}
	Temp_1 = Masiv[Temp];
	if (Sd == 10) //,    
	{
		if (state == On)
			Temp_1 |= (1 << NUMBER);
		else
			Temp_1 &= ~(1 << NUMBER);
		Masiv[Temp] = Temp_1;
	}
	else //,     
	{
		if (Temp_1 & (1 << NUMBER))
			NUMBER = 1;
		else
			NUMBER = 0;
	}
	return NUMBER; //   
}


//  :

//     0x01,      0x02
void Reading_Discrete_Output(unsigned char* Massiv, register unsigned char Number_)
{
	volatile unsigned int adres, Number_bits;
	register unsigned char Temp = 0, Data, Temp2 = 0, adres2 = 0, Temp3 = 2;
	adres = ModbasRtu_Register_address(3); // ,    
	if (adres > Number_) //,     
	{
		Error_modbasRtu(0x02); // 
	}
	else
	{
		Number_bits = ModbasRtu_Register_address(5); // ,   
		while (adres >= 8) //   ,     
		{
			adres = adres - 8; //    ,     
			Temp++; //        
		}
		Data = Massiv[Temp]; // 
		//      
		while (Number_bits > 0) //,     
		{
			Number_bits--;
			if (Data & (1 << adres))
			{
				Temp2 |= (1 << adres2);
			}
			adres2++;
			adres++;
			if (adres2 == 8)
			{
				adres2 = 0;
				Temp3++;
				Data_Rx_ModbasRtu[Temp3] = Temp2;
				Temp2 = 0;
			}
			if (adres == 8)
			{
				adres = 0;
				Temp++;
				Data = Massiv[Temp]; // 
			}
		}
		if (adres2 > 0)
		{
			Temp3++;
			Data_Rx_ModbasRtu[Temp3] = Temp2;
		}
		Data_Rx_ModbasRtu[2] = Temp3 - 2; //   (     )
		Temp3++;
		check_sum(Temp3); //     
	}
}

//     0x03,      0x04
void Read_analog_input(unsigned char* Massiv, register unsigned char Number_, unsigned char Vt)
//Vt -   
{
	volatile unsigned int address, Number_bits, Data;
	volatile unsigned  char Adress = 4;
	address = ModbasRtu_Register_address(3); // ,    
	if (address > Number_) //,     
	{
		Error_modbasRtu(0x02); //     
	}
	else
	{
		Number_bits = ModbasRtu_Register_address(5); // ,    (  )
		Data_Rx_ModbasRtu[2] = Number_bits * 2; //  ,   
		Adress = 3;
		while (Number_bits > 0)
		{
			if (Vt == 1) //,   -   
			{
				Data = Data_ModbasRtu_analog_input[address];
			}
			else
			{
				Data = Data_ModbasRtu_analog_Output[address];
			}
			address++;
			Massiv = &Data;
			Data_Rx_ModbasRtu[Adress++] = Massiv[1]; //  
			Data_Rx_ModbasRtu[Adress++] = Massiv[0]; //  
			Number_bits = Number_bits - 1;
		}
		check_sum(Adress); //     
	}
}

//    0x05
void Changing_Discrete_Output(void)
{
	register unsigned int address;
	address = ModbasRtu_Register_address(3); // ,    
	if (address > 11) //,      [11 -   ]
	{
		Error_modbasRtu(0x02);
	}
	else
	{
		if (Data_Rx_ModbasRtu[4] == 255)
			_Bin_input_Output(address, On, Data_ModbasRtu_Binary_Output, Change_output);
		else
			_Bin_input_Output(address, Off, Data_ModbasRtu_Binary_Output, Change_output);
	}
}

//    0x06
void analog_output_recording(void)
{
	register int address;
	address = ModbasRtu_Register_address(3);
	if (address > 11) //[11 -   ]
	{
		Error_modbasRtu(0x02);
	}
	else
	{
		Data_ModbasRtu_analog_Output[address] = ModbasRtu_Register_address(5); //,   
	}
}


//
void Error_modbasRtu(volatile unsigned char Temp_Error)
{
	Data_Rx_ModbasRtu[1] |= (1 << 7);
	Data_Rx_ModbasRtu[2] = Temp_Error; // 
	check_sum(3); //     
}


//  
void check_sum(register unsigned char Adress)
{
	register unsigned int RC;
	RC = crc_chk(Data_Rx_ModbasRtu, Adress); //  
	Data_Rx_ModbasRtu[Adress] = RC; //   
	Adress++;
	Data_Rx_ModbasRtu[Adress] = RC >> 8; //   
	quantity_Data_ModbasRtu = Adress;
}


//           
void modbasRtu_Answer()
{
	switch (Data_Rx_ModbasRtu[1])
	{
	case 1:
		//Modbus RTU    0x01
		Reading_Discrete_Output(Data_ModbasRtu_Binary_Output, 11); //[11 -   ]
		break;
	case 2:
		//Modbus RTU    0x02
		Reading_Discrete_Output(Data_ModbasRtu_Binary_input, 11); //[11 -   ]
		break;
	case 3:

		Read_analog_input(Data_ModbasRtu_analog_Output, 11, 0); //Modbus RTU     0x03 [11 -   ]
		break;
	case 4:

		Read_analog_input(Data_ModbasRtu_analog_input, 11, 1); //Modbus RTU     0x04 [11 -   ]
		break;
	case 5:
		//Modbus RTU     0x05
		Changing_Discrete_Output();
		break;
	case 6:
		//Modbus RTU     0x06
		analog_output_recording();
		break;
	case 15:
		//Modbus RTU      0x0F
		asm("nop"); // ,     
		//break;
	case 16:
		//Modbus RTU      0x10
		asm("nop");
		//break;
	default:
		//  
		Error_modbasRtu(0x01); //      
		break;
	}
}


//   

//  
char read_digital_inputs(volatile unsigned char Temp1)
{
	return _Bin_input_Output(Temp1, On, Data_ModbasRtu_Binary_input, discrete_output_reading); //     
}

//  
void change_digital_inputs(volatile unsigned char Temp1, volatile unsigned char Temp2)
{
	_Bin_input_Output(Temp1, Temp2, Data_ModbasRtu_Binary_input, Change_output);
}

//  
char read_digital_Output(volatile unsigned char Temp1)
{
	return _Bin_input_Output(Temp1, On, Data_ModbasRtu_Binary_Output, discrete_output_reading); //     
}

//  
void change_digital_Output(volatile unsigned char Temp1, volatile unsigned char Temp2)
{
	_Bin_input_Output(Temp1, Temp2, Data_ModbasRtu_Binary_Output, Change_output);
}

//   
void change_analogue_Output(volatile unsigned char nomer, int Data)
{
	Data_ModbasRtu_analog_Output[nomer] = Data;
}

//   
void change_analogue_input(volatile unsigned char nomer, int Data)
{
	Data_ModbasRtu_analog_input[nomer] = Data;
}

//   
int read_analogue_Output(volatile unsigned char nomer)
{
	return Data_ModbasRtu_analog_Output[nomer];
}

//   
int read_analogue_input(volatile unsigned char nomer)
{
	return Data_ModbasRtu_analog_input[nomer];
}


//(  rb_put    )
//  int rb_put(struct rb* _rb, char element)
void Data_Modbus_answer()
{

}